import Adafruit_BMP.BMP085 as BMP085 # Imports the BMP library
import time
import json
import os
import time
import pymysql
import requests
os.system('modprobe w1-gpio')
os.system('modprobe w1-therm')
externaltemp_sensor = "/sys/bus/w1/devices/28-0516a6d152ff/w1_slave"
#external = yellow shrinkwrap
internaltemp_sensor = "/sys/bus/w1/devices/28-0517b18349ff/w1_slave"
#internal == black shrinkwrap
# Create an 'object' containing the BMP180 data
sensor = BMP085.BMP085()

def main():
    i = 0
    while(i < 1000):
        for i in range(0,4):
            getbatchid = requests.get('http://ec2-18-221-239-178.us-east-2.compute.amazonaws.com/batch_id')
            batchdata = json.loads(getbatchid.text)
            cleandata = json.dumps(batchdata[0])
            finalData = json.loads(cleandata)
            userSetTemp = finalData['tempSet']
            batchID = finalData['id']
            print "User set temperature == " + str(userSetTemp)
            externalTemp = float(str(sensor.read_temperature()))*1.8 + 32
            print '\nBMP180: (External) Temp = {0:0.2f} *C'.format(externalTemp) # Temperature in Celcius
            print 'BMP180: Pressure = {0:0.2f} Pa'.format(sensor.read_pressure()) # The local pressure
            print 'BMP180: Altitude = {0:0.2f} m'.format(sensor.read_altitude()) # The current altitude
            print 'BMP180: Sealevel Pressure = {0:0.2f} Pa'.format(sensor.read_sealevel_pressure()) # The sea-level pressure
            print('DS18B20: (Internal) Temp: ' + str(read_temp(internaltemp_sensor)))
            print('DS18B20: (External) Temp: ' + str(read_temp(externaltemp_sensor)))
            print('Molecular Density == ' + str(sensor.read_pressure()/read_temp(internaltemp_sensor)))
            time.sleep(60)
        #write to api
        #remember to query/call api for batchid
        """
        if((sensor.read_pressure()*9.86923*(10**(-6)))< 1.003):
            i = i + 1
        else:
            i = 0
        if(i>100):
            r = requests.post(url = 'http://ec2-18-221-239-178.us-east-2.compute.amazonaws.com/set_info', data = {"done":1})
            break
        """
        try:
            post_data =  {"tempInside": str(read_temp(internaltemp_sensor)),"tempOutside":str(read_temp(externaltemp_sensor)), "pressure":str(sensor.read_pressure()*9.86923*(10**(-6))),"PH":"7","batch_id":str(batchID),"done":"0", "runTime":"0"}
            r = requests.post(url = 'http://ec2-18-221-239-178.us-east-2.compute.amazonaws.com/set_info', data = post_data)
            print r
        except:
            print "Wifi->API Connection ERROR"
        

def temp_raw(z):
    f = open(z, 'r')
    lines = f.readlines()
    f.close()
    return lines
def read_temp(z):
    lines = temp_raw(z)
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = temp_raw()
    temp_output = lines[1].find('t=')

    if temp_output != -1:
        temp_string = lines[1].strip()[temp_output+2:]
        temp_c = float(temp_string) / 1000.0
        temp_f = temp_c * 9.0 / 5.0 + 32.0
        return temp_f





main()

